﻿Type=Class
Version=2.7
@EndOfDesignText@
#Event: RatingChanged(Rating As Float,UserChanged As Boolean)
#IgnoreWarnings: 12
'Class module
Sub Class_Globals
	Private mTarget As Object
    Private mEventName As String
	Private RB As View
	Private mBase As Panel
	Dim RBLib As RatingBarLib

End Sub

'Initializes the object. You can add parameters to this method if needed.
'Add 'Small' to the CustomView Tag property in Designer to display small stars
'Make sure that the Customview in designer is large enough to dislay the stars you need.
'Required for both designer and Manual setup
Public Sub Initialize (TargetModule As Object, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
End Sub
'
#Region DesignerCreateView used to create view for designer
'Used by the designer when added there do not use manually Use Initialize and Setup!
Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	
	'Check which size of stars need to be displayed
	'Uses the default styles for stars
	Dim mSize As Int = 16842876
	'Check Tag for Size
	If Lbl.Tag = "Small"  Then
		mSize = 16842877
	End If
		
	'Create RatingBar Object and assign it to type View so that relevant View methods are inherited, such as Height and Width
	Dim R As Reflector
	RB=R.CreateObject2("android.widget.RatingBar",Array As Object(R.GetContext,Null,mSize),Array As String("android.content.Context","android.util.AttributeSet","java.lang.int"))
	Base.AddView(RB,0,0,Lbl.Width,Lbl.Height)
	
	'-2 = Wrap Content, will make the correct number of starts appear
	RB.Width=-2
	RB.Height=-2
	
	'Setup Callback using Java Lib
	RBLib.setCallback(RB,"RB")
	
End Sub
#End Region
'
#Region Setup used to create View manually
'Use when setting up the CustomView manually. Size can be 'Small' or nothing, anything else will be ignored
'Setup duplicates the designer create view so that we can also add this View manually if required
Sub Setup(Base As Panel,Size As String)
	mBase = Base
	
	'Check which size of stars need to be displayed
	'Uses the default styles for stars
	Dim mSize As Int = 16842876
	If Size ="Small" Then
		mSize = 16842877
	End If
	
	'Create RatingBar Object and assign it to type View so that relevant View methods are inherited, such as Height and Width
	Dim R As Reflector
	RB=R.CreateObject2("android.widget.RatingBar",Array As Object(R.GetContext,Null,mSize),Array As String("android.content.Context","android.util.AttributeSet","java.lang.int"))
	Base.AddView(RB,0,0,100%x,100%y)
	
	'-2 = Wrap Content, will make the correct number of starts appear
	RB.Width=-2
	RB.Height=-2
	
	'Setup CallBack using Java Lib
	RBLib.setCallback(RB,"RB")
End Sub
#End Region
'
#Region Methods from RatingBar API using reflection
'
#Region Get/Set Numstars
'Get or set the number of stars shown.
Sub getNumStars As Int
	Dim R As Reflector
	R.Target=RB
	Return R.RunMethod("getNumStars")
End Sub
Sub setNumStars(Num As Int)
	Dim R As Reflector
	R.Target=RB
	R.RunMethod2("setNumStars",Num,"java.lang.int")
End Sub
#End Region
#Region Get/Set Rating
'Gets or set the current rating (number of stars filled).
Sub getRating As Float
	Dim R As Reflector
	R.Target=RB
	Return R.RunMethod("getRating")
End Sub
Sub setRating(Rating As Float)
	Dim R As Reflector
	R.Target=RB
	R.RunMethod2("setRating",Rating,"java.lang.float")
End Sub
#End Region
#Region Get/Set StepSize
'Gets the step size of this rating bar. - No of starts per movement.
Sub getStepSize As Float
	Dim R As Reflector
	R.Target=RB
	Return R.RunMethod("getStepSize")
End Sub
Sub setStepSize(Size As Float)
	Dim R As Reflector
	R.Target=RB
	R.RunMethod2("setStepSize",Size,"java.lang.float")
End Sub
#End Region
#Region Get/Set IsIndicator
'Whether this rating bar should only be an indicator (thus non-changeable by the user).
Sub getisIndicator As Boolean
	Dim R As Reflector
	R.Target=RB
	Return R.RunMethod("isIndicator")
End Sub
Sub setIsIndicator (State As Boolean)
	Dim R As Reflector
	R.Target=RB
	R.RunPublicMethod("setIsIndicator",Array As Object(State),Array As String("java.lang.boolean"))
End Sub
#End Region
#Region Set MaxVal
'Set the range of the progress bar to 0... not quite sure what this can provide, but
'included it anyway
Sub setMax(MaxVal As Int)
	Dim R As Reflector
	R.Target=RB
	R.RunMethod2("setIsIndicator",MaxVal,"java.lang.int")
End Sub
#End Region
#End Region
'
#Region Class Specific Get/set
'Get or Set Rating Bar visibility
Sub setIsVisible(Visible As Boolean)
	mBase.Visible=Visible
End Sub
Sub getIsVisible As Boolean
	Return mBase.Visible
End Sub
#End Region
'
#Region Java CallBack Sub
'
'Callback from java lib
Sub RB_RatingChanged(Rating As Float,UserChanged As Boolean)
	
	Log(Rating&" "&UserChanged)
	Dim SubToCall As String =mEventName&"_RatingChanged"
	CallSub3(mTarget,SubToCall,Rating,UserChanged)
End Sub
#End Region